#include "stdafx.h"
#include "XMLHelper.h"

XmlDoc XmlLoadDocumentFromFile(CString szFile)
{
	EMULE_TRY
	XmlDoc spDoc;
	spDoc.CreateInstance(__uuidof(DOMDocument));
	if(spDoc->load(variant_t(szFile)) == VARIANT_TRUE)
		return spDoc;
	EMULE_CATCH
	return NULL;
}

XmlDoc XmlLoadDocumentFromStr(CString sXml)
{
	EMULE_TRY
	XmlDoc spDoc;
	spDoc.CreateInstance(__uuidof(DOMDocument));
	if(spDoc->loadXML(bstr_t(sXml)) == VARIANT_TRUE)
		return spDoc;
	EMULE_CATCH
	return NULL;
}

XmlDoc XmlCreateDocument()
{
	EMULE_TRY
	XmlDoc spDoc;
	spDoc.CreateInstance(__uuidof(DOMDocument));
	spDoc->async = VARIANT_FALSE;
	return spDoc;
	EMULE_CATCH
	return false;
}

XmlNode XmlCreateElement(XmlDoc spDoc, CString sElementName)
{
	EMULE_TRY
//	MSXML::IXMLDOMProcessingInstructionPtr spPI = 
//		m_spDoc->createProcessingInstruction(bstr_t(_T("xml")), bstr_t(_T("version=\"1.0\"")));
//	m_spDoc->appendChild(spPI);
	XmlNode spNode = spDoc->createElement(bstr_t(sElementName));
	if(spNode != NULL)
		if(SUCCEEDED(spDoc->appendChild(spNode)))
			return spNode;
	EMULE_CATCH
	return NULL;
}

bool XmlSetAttribute(XmlElement spElem, CString sAttribName, variant_t vtValue)
{
	EMULE_TRY
	return SUCCEEDED(spElem->setAttribute(bstr_t(sAttribName), vtValue));
	EMULE_CATCH
	return false;
}

CString XmlGetAttributeStr(XmlElement spElem, CString sAttribute)
{
	EMULE_TRY
	XmlNodeMap spAttrMap = spElem->attributes;
	if(spAttrMap != NULL)
	{
		XmlNode spNode = spAttrMap->getNamedItem(bstr_t(sAttribute));
		if(spNode)
			return (LPCTSTR)spNode->text;
	}
	EMULE_CATCH
	return _T("");
}

long XmlGetAttributeLong(XmlElement spElem, CString sAttribute, long lDefault/* = -1*/)
{
	EMULE_TRY
	XmlNodeMap spAttrMap = spElem->attributes;
	if(spAttrMap != NULL)
	{
		XmlNode spNode = spAttrMap->getNamedItem(bstr_t(sAttribute));
		if(spNode)
			return _ttol((LPCTSTR)spNode->text);
	}
	EMULE_CATCH
	return lDefault;
}
