#pragma once

// Specific includes needed by this class
#include "KnownFile.h"
#include "Loggable.h"

// CLanCast command target

class CLanCast : public CAsyncSocket, public CLoggable
{

public:
	CLanCast(CPreferences* in_prefs);
	~CLanCast();

	virtual void OnReceive(int nErrorCode);
	bool SendPacket(Packet* packet);

	void CLanCast::Start();
	void CLanCast::Stop();

	void CLanCast::BroadcastHash(CKnownFile* cur_file);

private:

void CLanCast::ReceiveHash(byte* pbytePacketBuf, uint32 nSize);

	BOOL JoinGroup(CString, UINT, UINT, BOOL);
	BOOL LeaveGroup();

	void SetLoopBack(BOOL);
	BOOL SetTTL(UINT nTTL);
	BOOL CreateSendingSocket(UINT, BOOL);
	BOOL CreateReceivingSocket(LPCTSTR, UINT);

	void static CALLBACK UDPTimerProc(HWND hwnd, UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
	bool CLanCast::ProcessPacket(byte* pbytePacketBuf, uint32 size, byte opcode);
		//(char* packet, uint16 size, byte opcode, char* host, uint16 port);

private:

	SOCKADDR_IN m_saHostGroup;	// SOCKADDR structure to hold IP/Port of the Host group to send data to it
	ip_mreq m_mrMReq;			// Contains IP and interface of the host group

	CAsyncSocket m_SendSocket;	// Socket for sending data to the host group

	bool bStarted;
	uint32 udp_timer;												// Timer to fire packet sends

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	CPreferences* m_prefs;											// Pointer to the preferences object

	bool GetLancastEnabled()		{return m_prefs->GetLancastEnabled();}	// Settings
	uint32 GetLancastIP()			{return m_prefs->GetLancastIP();}
	uint32 GetLancastSubnet()		{return m_prefs->GetLancastSubnet();}
	uint16 GetLancastPort()			{return m_prefs->GetLancastPort();}
	uint16 GetEmulePort()			{return m_prefs->GetPort();}					// Current Emule Listening Port

};

