//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#include "types.h"
#include "zlib/zlib.h"
#include "opcodes.h"

#pragma pack(1)
//			SERVER TO CLIENT
struct PacketHeader_Struct
{
	EnumProtocols	m_eEDonkeyProtocol;
	sint32			m_lPacketLength;
	EnumOpcodes		m_eCommand;
};
struct UDP_Header_Struct
{
	EnumProtocols	m_eEDonkeyProtocol;
	EnumOpcodes		m_eCommand;
};

struct LoginAnswer_Struct
{
	uint32		m_dwClientID;
};

struct Requested_Block_Struct
{
	uint32		m_dwStartOffset;
	uint32		m_dwEndOffset;
	uchar		m_fileHash[16];
};

struct Requested_File_Struct
{
	uchar		m_fileHash[16];
	uint32		m_dwLastAskedTime;
	byte		m_byteNumBadRequests;
};

struct Pending_Block_Struct
{
	Requested_Block_Struct	*m_pRequestedBlock;
	z_stream				*pZStream;		// zlib context
	BYTE					*pbyteRxDate;	// buffer with buffered rx data
	uint32					dwReceived;		// bytes received for requested block
	int						iZStreamErr;
};

struct Gap_Struct
{
	uint32		m_dwStartOffset;
	uint32		m_dwEndOffset;
};

struct ServerMet_Struct
{
	uint32		m_dwIP;
	uint16		m_uPort;
	uint32		m_dwTagCount;
};

struct TransferredData
{
	uint32		m_dwDataLength;
	uint32		m_dwTimeStamp;
};
#pragma pack()
